#ifndef glut__Context_h
#define glut__Context_h

#include "../gl/Context.h"

namespace glut
{
  class Window ;

  /**
   * GLUT用のGLコンテキスト クラス。
   */
  class Context : public gl::Context
  {
    // glut::Windowのみがglut::Contextを作成できる。
    friend class Window ;

  private :
    /**
     * コンストラクタ。
     *
     * @param owner コンテキストを保持するウィンドウ。
     */
    Context(Window *owner) ;


  public :
    /**
     * コンテキストの再描画を要求。
     */
    virtual void refresh() override ;


  private :
    Window *m_owner ;
  } ;
}

#endif
