#ifndef glut__InputConstants_h
#define glut__InputConstants_h

#include "../glall.h"

namespace glut
{
  /**
   * GLUT_KEY_*定数。
   *
   * 型安全性のために、定数をenum classとして再定義。
   */
  enum class SpecialKey : int
  {
    F1  = GLUT_KEY_F1,
    F2  = GLUT_KEY_F2,
    F3  = GLUT_KEY_F3,
    F4  = GLUT_KEY_F4,
    F5  = GLUT_KEY_F5,
    F6  = GLUT_KEY_F6,
    F7  = GLUT_KEY_F7,
    F8  = GLUT_KEY_F8,
    F9  = GLUT_KEY_F9,
    F10 = GLUT_KEY_F10,
    F11 = GLUT_KEY_F11,
    F12 = GLUT_KEY_F12,

    Left  = GLUT_KEY_LEFT,
    Up    = GLUT_KEY_UP,
    Right = GLUT_KEY_RIGHT,
    Down  = GLUT_KEY_DOWN,

    PageUp   = GLUT_KEY_PAGE_UP,
    PageDown = GLUT_KEY_PAGE_DOWN,
    Home     = GLUT_KEY_HOME,
    End      = GLUT_KEY_END,
    Insert   = GLUT_KEY_INSERT,
  } ;

  /**
   * GLUT_*_BUTTON定数。
   *
   * 型安全性のために、定数をenum classとして再定義。
   */
  enum class MouseButton : int
  {
    Left   = GLUT_LEFT_BUTTON,
    Right  = GLUT_RIGHT_BUTTON,
    Middle = GLUT_MIDDLE_BUTTON,
  } ;

  /**
    * GLUT_UP/GLUT_DOWN定数。
    *
    * 型安全性のために、定数をenum classとして再定義。
    */
  enum class ButtonState : int
  {
    Up   = GLUT_UP,
    Down = GLUT_DOWN,
  } ;

  /**
    * GLUT_LEFT/GLUT_ENTERED定数。
    *
    * 型安全性のために、定数をenum classとして再定義。
    */
  enum class MouseEntry : int
  {
    Enter = GLUT_ENTERED,
    Leave = GLUT_LEFT,
  } ;
}

#endif
